#ifndef SBK_KNotificationActionWrapper_H
#define SBK_KNotificationActionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <knotification.h>

namespace PySide { class DynamicQMetaObject; }

class KNotificationActionWrapper : public KNotificationAction
{
public:
    KNotificationActionWrapper(const KNotificationActionWrapper &) = delete;
    KNotificationActionWrapper& operator=(const KNotificationActionWrapper &) = delete;
    KNotificationActionWrapper(KNotificationActionWrapper &&) = delete;
    KNotificationActionWrapper& operator=(KNotificationActionWrapper &&) = delete;

    KNotificationActionWrapper(::QObject * parent = nullptr);
    KNotificationActionWrapper(const ::QString & label);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~KNotificationActionWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_KNotificationActionWrapper_H

